# coding: utf-8

"""
    Equinix Fabric API v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from equinix.services.fabricv4.models.port_order_purchase_order import PortOrderPurchaseOrder
from equinix.services.fabricv4.models.port_order_signature import PortOrderSignature
from typing import Optional, Set
from typing_extensions import Self

class PortOrder(BaseModel):
    """
    PortOrder
    """ # noqa: E501
    purchase_order: Optional[PortOrderPurchaseOrder] = Field(default=None, alias="purchaseOrder")
    order_id: Optional[StrictStr] = Field(default=None, description="Order Identification", alias="orderId")
    customer_reference_id: Optional[StrictStr] = Field(default=None, description="Customer order reference Id", alias="customerReferenceId")
    order_number: Optional[StrictStr] = Field(default=None, description="Order Reference Number", alias="orderNumber")
    uuid: Optional[StrictStr] = Field(default=None, description="Equinix-assigned order identifier, this is a derived response atrribute")
    signature: Optional[PortOrderSignature] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["purchaseOrder", "orderId", "customerReferenceId", "orderNumber", "uuid", "signature"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PortOrder from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of purchase_order
        if self.purchase_order:
            _dict['purchaseOrder'] = self.purchase_order.to_dict()
        # override the default output from pydantic by calling `to_dict()` of signature
        if self.signature:
            _dict['signature'] = self.signature.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PortOrder from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "purchaseOrder": PortOrderPurchaseOrder.from_dict(obj["purchaseOrder"]) if obj.get("purchaseOrder") is not None else None,
            "orderId": obj.get("orderId"),
            "customerReferenceId": obj.get("customerReferenceId"),
            "orderNumber": obj.get("orderNumber"),
            "uuid": obj.get("uuid"),
            "signature": PortOrderSignature.from_dict(obj["signature"]) if obj.get("signature") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


