# coding: utf-8

"""
    Equinix Fabric API v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from equinix.services.fabricv4.models.route_aggregations_change_operation import RouteAggregationsChangeOperation
from equinix.services.fabricv4.models.route_aggregations_change_type import RouteAggregationsChangeType
from typing import Optional, Set
from typing_extensions import Self

class RouteAggregationChangeData(BaseModel):
    """
    Current state of latest Route Aggregation change
    """ # noqa: E501
    status: Optional[StrictStr] = Field(default=None, description="Current outcome of the change flow")
    created_by: Optional[StrictStr] = Field(default=None, description="Created by User Key", alias="createdBy")
    created_date_time: Optional[datetime] = Field(default=None, description="Set when change flow starts", alias="createdDateTime")
    updated_by: Optional[StrictStr] = Field(default=None, description="Updated by User Key", alias="updatedBy")
    updated_date_time: Optional[datetime] = Field(default=None, description="Set when change object is updated", alias="updatedDateTime")
    information: Optional[StrictStr] = Field(default=None, description="Additional information")
    data: Optional[RouteAggregationsChangeOperation] = None
    uuid: StrictStr = Field(description="Uniquely identifies a change")
    type: RouteAggregationsChangeType
    href: Optional[StrictStr] = Field(default=None, description="Route AGGREGATION Change URI")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["uuid", "type", "href"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['COMPLETED', 'FAILED', 'REQUESTED']):
            raise ValueError("must be one of enum values ('COMPLETED', 'FAILED', 'REQUESTED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RouteAggregationChangeData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RouteAggregationChangeData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "uuid": obj.get("uuid"),
            "type": obj.get("type"),
            "href": obj.get("href")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


