# coding: utf-8

"""
    Equinix Fabric API v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from equinix.services.fabricv4.models.changelog import Changelog
from equinix.services.fabricv4.models.route_filter_state import RouteFilterState
from equinix.services.fabricv4.models.route_filters_base_type import RouteFiltersBaseType
from equinix.services.fabricv4.models.route_filters_change import RouteFiltersChange
from equinix.services.fabricv4.models.route_filters_data_not_matched_rule_action import RouteFiltersDataNotMatchedRuleAction
from equinix.services.fabricv4.models.route_filters_data_project import RouteFiltersDataProject
from typing import Optional, Set
from typing_extensions import Self

class RouteFiltersData(BaseModel):
    """
    RouteFiltersData
    """ # noqa: E501
    href: Optional[StrictStr] = Field(default=None, description="Route filter URI")
    type: Optional[RouteFiltersBaseType] = None
    uuid: Optional[StrictStr] = Field(default=None, description="Route filter identifier")
    name: Optional[StrictStr] = None
    description: Optional[StrictStr] = Field(default=None, description="Customer-provided connection description")
    state: Optional[RouteFilterState] = None
    change: Optional[RouteFiltersChange] = None
    not_matched_rule_action: Optional[RouteFiltersDataNotMatchedRuleAction] = Field(default=None, alias="notMatchedRuleAction")
    connections_count: Optional[StrictInt] = Field(default=None, alias="connectionsCount")
    rules_count: Optional[StrictInt] = Field(default=None, alias="rulesCount")
    project: Optional[RouteFiltersDataProject] = None
    changelog: Optional[Changelog] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["href", "type", "uuid", "name", "description", "state", "change", "notMatchedRuleAction", "connectionsCount", "rulesCount", "project", "changelog"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RouteFiltersData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of change
        if self.change:
            _dict['change'] = self.change.to_dict()
        # override the default output from pydantic by calling `to_dict()` of project
        if self.project:
            _dict['project'] = self.project.to_dict()
        # override the default output from pydantic by calling `to_dict()` of changelog
        if self.changelog:
            _dict['changelog'] = self.changelog.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RouteFiltersData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "href": obj.get("href"),
            "type": obj.get("type"),
            "uuid": obj.get("uuid"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "state": obj.get("state"),
            "change": RouteFiltersChange.from_dict(obj["change"]) if obj.get("change") is not None else None,
            "notMatchedRuleAction": obj.get("notMatchedRuleAction"),
            "connectionsCount": obj.get("connectionsCount"),
            "rulesCount": obj.get("rulesCount"),
            "project": RouteFiltersDataProject.from_dict(obj["project"]) if obj.get("project") is not None else None,
            "changelog": Changelog.from_dict(obj["changelog"]) if obj.get("changelog") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


