# coding: utf-8

"""
    Equinix Fabric API v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from equinix.services.fabricv4.models.changelog import Changelog
from equinix.services.fabricv4.models.resource_selector import ResourceSelector
from equinix.services.fabricv4.models.stream_alert_rule_metric_name import StreamAlertRuleMetricName
from equinix.services.fabricv4.models.stream_alert_rule_operand import StreamAlertRuleOperand
from equinix.services.fabricv4.models.stream_alert_rule_state import StreamAlertRuleState
from equinix.services.fabricv4.models.stream_alert_rule_type import StreamAlertRuleType
from typing import Optional, Set
from typing_extensions import Self

class StreamAlertRule(BaseModel):
    """
    Stream object
    """ # noqa: E501
    href: Optional[StrictStr] = Field(default=None, description="Stream Alert Rule URI")
    uuid: Optional[StrictStr] = Field(default=None, description="Equinix-assigned access point identifier")
    type: Optional[StreamAlertRuleType] = None
    name: Optional[StrictStr] = Field(default=None, description="Customer-provided stream alert rule name")
    description: Optional[StrictStr] = Field(default=None, description="Customer-provided stream alert rule description")
    state: Optional[StreamAlertRuleState] = None
    enabled: Optional[StrictBool] = Field(default=True, description="Stream alert rule enabled status")
    metric_name: Optional[StreamAlertRuleMetricName] = Field(default=None, alias="metricName")
    resource_selector: Optional[ResourceSelector] = Field(default=None, alias="resourceSelector")
    window_size: Optional[StrictStr] = Field(default=None, description="Stream alert rule metric window size", alias="windowSize")
    operand: Optional[StreamAlertRuleOperand] = None
    warning_threshold: Optional[StrictStr] = Field(default=None, description="Stream alert rule metric warning threshold", alias="warningThreshold")
    critical_threshold: Optional[StrictStr] = Field(default=None, description="Stream alert rule metric critical threshold", alias="criticalThreshold")
    change_log: Optional[Changelog] = Field(default=None, alias="changeLog")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["href", "uuid", "type", "name", "description", "state", "enabled", "metricName", "resourceSelector", "windowSize", "operand", "warningThreshold", "criticalThreshold", "changeLog"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StreamAlertRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "href",
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of resource_selector
        if self.resource_selector:
            _dict['resourceSelector'] = self.resource_selector.to_dict()
        # override the default output from pydantic by calling `to_dict()` of change_log
        if self.change_log:
            _dict['changeLog'] = self.change_log.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StreamAlertRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "href": obj.get("href"),
            "uuid": obj.get("uuid"),
            "type": obj.get("type"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "state": obj.get("state"),
            "enabled": obj.get("enabled") if obj.get("enabled") is not None else True,
            "metricName": obj.get("metricName"),
            "resourceSelector": ResourceSelector.from_dict(obj["resourceSelector"]) if obj.get("resourceSelector") is not None else None,
            "windowSize": obj.get("windowSize"),
            "operand": obj.get("operand"),
            "warningThreshold": obj.get("warningThreshold"),
            "criticalThreshold": obj.get("criticalThreshold"),
            "changeLog": Changelog.from_dict(obj["changeLog"]) if obj.get("changeLog") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


